;;; -*- Mode: Lisp; Package: OUTLINE-TREE -*-
;;; outline-tree.l --- TreeView.dll pAEgC

;; Copyright (C) 2002 OHKUBO Hiroshi <konata_o@hotmail.com>

;; Author: OHKUBO Hiroshi <konata_o@hotmail.com>
;; Time-stamp: <2002/05/20 00:26:50 +0900>

;;; Commentary:

;; Description:
;;
;;  kazu.y ̌JĂ TreeView.dll, TreeView.l 
;;  lXȗprɎgpłϑf炵̂łB
;;
;;  outline-tree.l  TreeView.dll p xyzzy ɃAEgC@\
;;  ǉ܂B
;;  쐬ɂ TreeView.l ώQlɂĂ܂B
;;

;; o邱:
;;
;;      EK\wł̃AEgC쐬
;;      EeLXg̃AEgC쐬
;;      Ehtml-mode, html+-mode, xml-mode ̃AEgC쐬(vݒ)
;;      Elisp-mode ł̕\
;;

;; Installation:
;;
;;      1. TreeView.dll gpł悤ɂ܂B(ex. ~/ ւ̃Rs[)
;;
;;      2. 𓀂 outline-tree.l  ~/site-lisp ɃRs[܂B
;;         outline-tree-toolbar.bmp  ~/etc ɃRs[܂B
;;
;;      3. (KvȂ)oCgRpC܂B
;;
;;              M-x byte-compile-file
;;
;;      4. .xyzzy ܂ siteinit.l Ɉȉ̃R[hǉ܂B
;;
;;              (load-library "outline-tree")
;;
;;      5. KvȂ΃L[oCh̐ݒ̃R[hǉ܂B
;;
;;              F
;;              (add-hook '*find-file-hooks* 'olt::outline-make)
;;
;;              ;(setq olt:*outline-size* 200)
;;              ;(setq olt:*outline-position* olt:XPIS_TOP)
;;
;;              (setq olt:*outline-emphasis-attribute* '(:background 3 :bold t))
;;              (setq olt:*outline-bk-color* #x202020)
;;              (setq olt:*outline-text-color* #x8080f0)
;;              (setq olt:*outline-modify-bk-color* #x000040)
;;              (setq olt:*outline-modify-text-color* nil)
;;
;;              (setq olt:*outline-action-immediately* t)
;;              (add-hook '*post-command-hook* 'olt:outline-set-node-by-cursor-for-hook)
;;              (setq-default olt:*outline-range-type-narrow* nil)
;;              (setq-default olt:*outline-view-restriction* nil)
;;              (setq-default olt:*outline-view-emphasis* t)
;;              (setq-default hide-restricted-region nil)
;;
;;              (global-set-key #\C-M-Up 'olt:outline-operation-up)
;;              (global-set-key #\C-M-Down 'olt:outline-operation-down)
;;              (global-set-key #\C-M-Left 'olt:outline-operation-left)
;;              (global-set-key #\C-M-Right 'olt:outline-operation-right)
;;
;;              (set-extended-key-translate-table exkey-C-M-return #\F20)
;;              (global-set-key #\F20 'olt:outline-node-action)
;;              (set-extended-key-translate-table exkey-C-return #\F21)
;;              ;(global-set-key #\F21 'olt:outline-set-node-by-cursor)
;;              ;(global-set-key #\F21 'olt:outline-make)
;;              (global-set-key #\F21 'olt:outline-set-node-by-cursor-or-make)
;;              (set-extended-key-translate-table exkey-C-tab #\F22)
;;              (global-set-key #\F22 'olt:outline-focus-outline)
;;
;;      6. L̐ݒ𔽉f邽߂ɁAxyzzy ċN܂B
;;         siteinit.l ɋLqꍇ xyzzy ă_vċN܂B
;;
;;      7. KvȂ΃j[́u\vuc[o[vɒǉĂ
;;         uOutlinev`FbNAc[o[\܂B

;; Uninstallation:
;;
;;      1. M-x outline-tree::uninstall-outline-tree ƃ^CvA
;;         c[o[̏ xyzzy 폜܂B
;;
;;      2. outline-tree.l ɊւLq폜܂B
;;
;;      3. siteinit.l ɋLqĂꍇ xyzzy ă_v܂B
;;

;; Changes:
;;      Sun, 19 May 2002 22:15:02 +0900
;;              E\̐Fw
;;              Ehook ̒ǉ
;;              ETreeView ̕FAwiF̕ύX
;;              Eoutline 쐬ɕҏWꍇ TreeView ̐FύX
;;              Etreeview-disable-char-jump ݒϐ *outline-disable-char-jump* ̒ǉB
;;                nil ̏ꍇ̌؂SsĂ܂񂪁AȂƂ
;;                *outline-operation-??-keys*  nil ɂقƎv܂B
;;              Eoutline-close ɑΉ̂ outline-open 낤ƂƂŁA
;;                outline-open  outline-make ̊֐ύXB
;;
;;      Sun, 12 May 2002 22:25:44 +0900
;;              EŁB
;;              EɌ^SƂǂ߂Ȃ\܂B
;;

;; Todo:
;;
;;      ER[h܂Ƃ
;;      ETreeView ł Up, Down, Left, Right L[̑ȂƂ}
;;        ̃L[ƓlɈ
;;      EAEgC\֐I_CAO
;;          EK\^CvI񂾏ꍇ͐K\̓͂
;;          EeLXg^CvI񂾏ꍇ́Auv̓͂
;;            sXLbv̓͂B
;;          Ebuffer-local ȕϐŁuǂ̊֐gvuǂ̐K\gv
;;            uǂ̌ZbggvۑB
;;          Ebuffer-local ȕϐŊ֐Iɐݒ肳ĂȂꍇ
;;            ftHg̊֐ōsB
;;      EK\AEgCł :dummy-node ̎
;;      E:buffer-node ȉ̃m[h̐ݒ :buffer-node ɕۑ
;;      Eoutline \ۂ܂ TreeView ̕\A펞؂ւ
;;      E\̉P
;;      Erange őO nil Ȃ (point-min) A낪 nil Ȃ (point-max) ܂
;;      Eoutline-make-tag-mode ̉P
;;      Eoutline-make-lisp-mode ̉P
;;        Eoutline-make-lisp-mode  read pēǂł邽߁A
;;          ܂݂ȂpbP[W̃V{ǂ񂾂肷ƃG[ƂȂ̂CB
;;      Em[h̕ҏWAړ
;;      E^uƓɂȂ悤Ƀm[h\[g
;;      Ehook ̒ǉ
;;      Ȇ
;;

;; Memo:
;;
;; (:buffer-node <func> <buffer> <setting>)
;; (:node        <func> <wide-range> <narrow-range> <title-range>)
;; (:header-node <func> <wide-range> <narrow-range> <title-range>)
;; (:info-node   <func> <wide-range> <narrow-range> <title-range>)
;; (:dummy-node  <func> <wide-range> <narrow-range> <title-range>)
;;
;; :buffer-node obt@
;; :node        ʂ̃m[h
;; :header-node <擪> m[h
;; :info-node   tree ŕ\邾̃m[hBSɐem[hɏ]
;; :dummy-node  KwAKwȂAOKwAƂꍇ
;;              KwɎgpm[h
;;
;; E<func>  function w肳ĂꍇAm[hI function s
;; E<narrow-range>  nil ̏ꍇ <wide-range> ̒lp
;; E<title-range>  nil ł悢

;;; Code:

(provide "outline-tree")

(eval-when (:compile-toplevel :load-toplevel :execute)
  (require "foreign")
  (require "wip/winapi"))
(require "virtual-keys")

(eval-when (:compile-toplevel :load-toplevel :execute)
  (unless (find-package "outline-tree")
    (defpackage "outline-tree"
      (:nicknames "olt")
      (:use "lisp" "editor"))))

(in-package "outline-tree")

(export '(*treeview-dll-load-path*
          *outline-size*
          *outline-position*
          *outline-disable-char-jump*
          *outline-bk-color*
          *outline-text-color*
          *outline-modify-bk-color*
          *outline-modify-text-color*
          *outline-action-immediately*
          *outline-range-type-narrow*
          *outline-view-restriction*
          *outline-view-emphasis*
          *outline-operation-up-keys*
          *outline-operation-down-keys*
          *outline-operation-left-keys*
          *outline-operation-right-keys*
          *outline-expand-toggle-keys*
          *outline-action-keys*
          *outline-focus-editor-keys*
          *outline-close-keys*
;         *outline-edit-label-keys*
          *outline-make-regexp-list*
          *outline-make-function*
          *outline-emphasis-attribute*
          *outline-tag*
          *outline-header-node-title*
          *outline-dummy-node-title*

          *outline-topic-mark-string*
          *outline-topic-mark-string-group-list*

          *outline-open-hook*
          *outline-make-hook*
          *outline-close-hook*
          *outline-focus-editor-hook*
          *outline-focus-outline-hook*

          treeview-dll-define-function
          outline-operation-up
          outline-operation-down
          outline-operation-left
          outline-operation-right
          outline-expand-toggle
          
          outline-focus-editor
          outline-focus-outline
          outline-set-cursor-by-node
          outline-set-node-by-cursor
          outline-set-node-by-cursor-for-hook
          outline-set-node-by-cursor-or-make
          outline-open
          outline-make
          outline-close
          outline-delete-buffer
          outline-node-action
          outline-set-buffer
          outline-make-topic
          outline-make-lisp-mode
          outline-make-tag-mode
          
          outline-toggle-action-immediately
          outline-toggle-range-type-narrow
          outline-toggle-view-restriction
          outline-toggle-view-emphasis
          outline-toggle-chase
          toggle-hide-restricted-region
          ))

(when (and (fboundp 'treeview-open-p)
           (treeview-open-p))
  (outline-close))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TreeView.l 
(c:*define-c-type winapi:LPSTR    LPTSTR)
(c:*define-c-type winapi:LPCSTR   LPCTSTR)
(c:*define-c-type (winapi:UINT *) PUINT)
(c:*define-c-type winapi:HANDLE   HTREEITEM)

(c:*define-c-struct TVITEM
  (winapi:UINT    mask           )
  (HTREEITEM      hItem          )
  (winapi:UINT    state          )
  (winapi:UINT    stateMask      )
  (LPTSTR         pszText        )
  (c:int          cchTextMax     )
  (c:int          iImage         )
  (c:int          iSelectedImage )
  (c:int          cChildren      )
  (winapi:LPARAM  lParam         ))

;; xpi.h
(c:*define XPIS_LEFT   0)
(c:*define XPIS_TOP    1)
(c:*define XPIS_RIGHT  2)
(c:*define XPIS_BOTTOM 3)

; X^Cݒp - ModifyStyle ()
(c:*define TVS_HASBUTTONS       #x0001)
(c:*define TVS_HASLINES         #x0002)
(c:*define TVS_LINESATROOT      #x0004)
(c:*define TVS_EDITLABELS       #x0008)
(c:*define TVS_DISABLEDRAGDROP  #x0010)
(c:*define TVS_SHOWSELALWAYS    #x0020)
(c:*define TVS_RTLREADING       #x0040)
(c:*define TVS_NOTOOLTIPS       #x0080)
(c:*define TVS_CHECKBOXES       #x0100)
(c:*define TVS_TRACKSELECT      #x0200)
(c:*define TVS_SINGLEEXPAND     #x0400)
(c:*define TVS_INFOTIP          #x0800)
(c:*define TVS_FULLROWSELECT    #x1000)
(c:*define TVS_NOSCROLL         #x2000)
(c:*define TVS_NONEVENHEIGHT    #x4000)
(c:*define TVS_NOHSCROLL        #x8000)

; hitem ̑Ɏg - InsertItem ()
(c:*define TVI_ROOT       (- 0 #x10000))
(c:*define TVI_FIRST      (- 0 #x0FFFF))
(c:*define TVI_LAST       (- 0 #x0FFFE))
(c:*define TVI_SORT       (- 0 #x0FFFD))

; ύXӏ̃}XN - InsertItem (), SetItem ()
(c:*define TVIF_TEXT          #x0001)
(c:*define TVIF_IMAGE         #x0002)
(c:*define TVIF_PARAM         #x0004)
(c:*define TVIF_STATE         #x0008)
(c:*define TVIF_HANDLE        #x0010)
(c:*define TVIF_SELECTEDIMAGE #x0020)
(c:*define TVIF_CHILDREN      #x0040)

; ԕύXp - InsertItem ()
(c:*define TVIS_SELECTED        #x0002)
(c:*define TVIS_CUT             #x0004)
(c:*define TVIS_DROPHILITED     #x0008)
(c:*define TVIS_BOLD            #x0010)
(c:*define TVIS_EXPANDED        #x0020)
(c:*define TVIS_EXPANDEDONCE    #x0040)
(c:*define TVIS_OVERLAYMASK     #x0F00)
(c:*define TVIS_STATEIMAGEMASK  #xF000)
(c:*define TVIS_USERMASK        #xF000)
(c:*define TVIS_EXPANDPARTIAL   #x0080)

; Expand () p
(c:*define TVE_COLLAPSE       #x0001)
(c:*define TVE_EXPAND         #x0002)
(c:*define TVE_TOGGLE         #x0003)
(c:*define TVE_COLLAPSERESET  #x8000)
(c:*define TVE_EXPANDPARTIAL  #x4000)

; GetNextItem (), Select ()
(c:*define TVGN_ROOT             #x0000)
(c:*define TVGN_NEXT             #x0001)
(c:*define TVGN_PREVIOUS         #x0002)
(c:*define TVGN_PARENT           #x0003)
(c:*define TVGN_CHILD            #x0004)
(c:*define TVGN_FIRSTVISIBLE     #x0005)
(c:*define TVGN_NEXTVISIBLE      #x0006)
(c:*define TVGN_PREVIOUSVISIBLE  #x0007)
(c:*define TVGN_DROPHILITE       #x0008)
(c:*define TVGN_CARET            #x0009)
(c:*define TVGN_LASTVISIBLE      #x000A)


;;
(c:*define TV_FIRST               #x1100)
(c:*define TVM_SETBKCOLOR         (+ TV_FIRST 29))
(c:*define TVM_SETTEXTCOLOR       (+ TV_FIRST 30))
(c:*define TVM_GETBKCOLOR         (+ TV_FIRST 31))
(c:*define TVM_GETTEXTCOLOR       (+ TV_FIRST 32))
(c:*define TVM_SETINSERTMARKCOLOR (+ TV_FIRST 37))
(c:*define TVM_GETINSERTMARKCOLOR (+ TV_FIRST 38))

;; F
(c:*define CLR_NONE                #xFFFFFFFF)
(c:*define CLR_DEFAULT             #xFF000000)

(c:define-dll-entry winapi:BOOL RedrawWindow
  (winapi:HWND (winapi:RECT *) winapi:HRGN winapi:UINT) "user32")

(c:define RDW_INVALIDATE          #x0001)
(c:define RDW_INTERNALPAINT       #x0002)
(c:define RDW_ERASE               #x0004)

(c:define RDW_VALIDATE            #x0008)
(c:define RDW_NOINTERNALPAINT     #x0010)
(c:define RDW_NOERASE             #x0020)

(c:define RDW_NOCHILDREN          #x0040)
(c:define RDW_ALLCHILDREN         #x0080)

(c:define RDW_UPDATENOW           #x0100)
(c:define RDW_ERASENOW            #x0200)

(c:define RDW_FRAME               #x0400)
(c:define RDW_NOFRAME             #x0800)

(defvar *treeview-dll-load-path*
  (list
   (user-homedir-pathname)
   (concat (user-homedir-pathname) "etc/")
   (concat (user-homedir-pathname) "site-lisp/")
   (si:system-root)
   (etc-path)
   (concat (si:system-root) "etc/")
   (concat (si:system-root) "site-lisp/")
   "")
  "TreeView.dll ̌pX")

(defun treeview-dll-define-function (dll)
  "treeview.dll 𒼐ڗp֐̒`"
  (let* ((dll-exist-p (and (file-exist-p dll)
                           (not (file-directory-p dll))))
         (fullpath (if dll-exist-p (truename dll) dll)))
    (if (and (fboundp 'treevew-open-p)
             (treeview-open-p))
        (treeview-close))
    (c:define-dll-entry c:int treeview-dll-create (winapi:HWND (c:void *)) dll "Create")
    (c:define-dll-entry c:int treeview-dll-create-ex (winapi:HWND (c:void *) c:int winapi:DWORD) dll "CreateEx")
    (c:define-dll-entry c:int treeview-dll-close (c:int) dll "Close")
    (c:define-dll-entry winapi:HWND treeview-dll-get-hwnd (c:int) dll "GetHwnd")
    (c:define-dll-entry winapi:HWND treeview-dll-get-htree (c:int) dll "GetHtree")
    (c:define-dll-entry winapi:BOOL treeview-dll-modify-style (c:int winapi:DWORD winapi:DWORD winapi:UINT) dll "ModifyStyle")

    (c:define-dll-entry winapi:UINT treeview-dll-get-count (c:int) dll "GetCount")
    ; GetIndent
    ; SetIndent
    ; GetImageList
    ; SetImageList
    (c:define-dll-entry HTREEITEM treeview-dll-get-next-item (c:int HTREEITEM winapi:UINT) dll "GetNextItem")
    (c:define-dll-entry winapi:BOOL treeview-dll-item-has-children (c:int HTREEITEM) dll "ItemHasChildren")
    (c:define-dll-entry HTREEITEM treeview-dll-get-child-item (c:int HTREEITEM) dll "GetChildItem")
    (c:define-dll-entry HTREEITEM treeview-dll-get-next-sibling-item (c:int HTREEITEM) dll "GetNextSiblingItem")
    (c:define-dll-entry HTREEITEM treeview-dll-get-prev-sibling-item (c:int HTREEITEM) dll "GetPrevSiblingItem")
    (c:define-dll-entry HTREEITEM treeview-dll-get-parent-item (c:int HTREEITEM) dll "GetParentItem")
    ;; GetFirstVisibleItem
    ;; GetNextVisibleItem
    ;; GetPrevVisibleItem
    (c:define-dll-entry HTREEITEM treeview-dll-get-selected-item (c:int) dll "GetSelectedItem")
    ; GetDropHilightItem
    (c:define-dll-entry HTREEITEM treeview-dll-get-root-item (c:int) dll "GetRootItem")
    (c:define-dll-entry winapi:BOOL treeview-dll-get-item (c:int (TVITEM *)) dll "GetItem")
    (c:define-dll-entry winapi:BOOL treeview-dll-set-item
      (c:int HTREEITEM winapi:UINT LPCTSTR c:int c:int winapi:UINT winapi:UINT winapi:LPARAM) dll "SetItem")
    (c:define-dll-entry winapi:UINT treeview-dll-get-item-state (c:int HTREEITEM winapi:UINT) dll "GetItemState")
    (c:define-dll-entry winapi:BOOL treeview-dll-set-item-state (c:int HTREEITEM winapi:UINT winapi:UINT) dll "SetItemState")
    ; GetItemImage
    ; SetItemImage
    (c:define-dll-entry winapi:BOOL treeview-dll-get-item-text (c:int HTREEITEM LPTSTR c:int) dll "GetItemText")
    (c:define-dll-entry winapi:BOOL treeview-dll-set-item-text (c:int HTREEITEM LPCTSTR) dll "SetItemText")
    (c:define-dll-entry winapi:DWORD treeview-dll-get-item-data (c:int HTREEITEM) dll "GetItemData")
    (c:define-dll-entry winapi:BOOL treeview-dll-set-item-data (c:int HTREEITEM winapi:DWORD) dll "SetItemData")
    ; GetItemRect
    ; GetEditControl
    ; GetVisibleCount
    ; GetToolTips
    ;; GetBkColor
    ;; SetBkColor
    ; GetItemHeight
    ; SetItemHeight
    ;; GetTextColor
    ;; SetTextColor
    ; SetInsertMark
    ; GetCheck
    ; SetCheck
    ;; GetInsertMarkColor
    ;; SetInsertMarkColor

    ;; 
    (c:define-dll-entry HTREEITEM treeview-dll-insert-item
      (c:int winapi:UINT LPCTSTR c:int c:int winapi:UINT winapi:UINT winapi:LPARAM HTREEITEM HTREEITEM) dll "InsertItem")
    (c:define-dll-entry winapi:BOOL treeview-dll-delete-item (c:int HTREEITEM) dll "DeleteItem")
    (c:define-dll-entry winapi:BOOL treeview-dll-delete-all-items (c:int) dll "DeleteAllItems")
    (c:define-dll-entry winapi:BOOL treeview-dll-expand (c:int HTREEITEM winapi:UINT) dll "Expand")
    (c:define-dll-entry winapi:BOOL treeview-dll-select (c:int HTREEITEM winapi:UINT) dll "Select")
    ; SelectItem
    ; SelectDropTarget
    ; SelectSetFirstVisible
    (c:define-dll-entry winapi:HWND treeview-dll-edit-label (c:int HTREEITEM) dll "EditLabel")
    ; HitTest
    ; CreateDragImage
    (c:define-dll-entry winapi:UINT treeview-dll-sort-children (c:int HTREEITEM) dll "SortChildren")
    ; EnsureVisible
    ; SortChildrenCB

    ;; callback
    (c:define-dll-entry winapi:BOOL treeview-dll-set-click-callback (c:int (c:void *)) dll "SetClickCallback")
    (c:define-dll-entry winapi:BOOL treeview-dll-set-dblclk-callback (c:int (c:void *)) dll "SetDblclkCallback")
    (c:define-dll-entry winapi:BOOL treeview-dll-set-rclick-callback (c:int (c:void *)) dll "SetRclickCallback")
    (c:define-dll-entry winapi:BOOL treeview-dll-set-keydown-callback (c:int (c:int *)) dll "SetKeyDownCallback")
    (c:define-dll-entry winapi:BOOL treeview-dll-set-edit-label-callback (c:int (c:void *)) dll "SetEditLabelCallback")

    ;; icon
    (c:define-dll-entry c:int treeview-dll-add-file-icon (c:int LPCTSTR) dll "AddFileIcon")
    (c:define-dll-entry c:int treeview-dll-add-icon (c:int winapi:HICON) dll "AddIcon")
    (c:define-dll-entry winapi:BOOL treeview-dll-remove-icon (c:int c:int) dll "RemoveIcon")
    (c:define-dll-entry winapi:BOOL treeview-dll-remove-all-icons (c:int) dll "RemoveAllIcons")

    ;; ̑
    (c:define-dll-entry winapi:BOOL treeview-dll-disable-char-jump (c:int winapi:BOOL) dll "DisableCharJump")
    (c:define-dll-entry c:int treeview-dll-simple-track-popup-menu (LPCTSTR) dll "SimpleTrackPopupMenu")


    (defun treeview-dll-pathname ()
      "gpĂ dll ̃pXԂ"
      fullpath)
    (gc)
    dll-exist-p))

(let (dll (dll-filename "TreeView.dll"))
  (dolist (dir *treeview-dll-load-path*
               (treeview-dll-define-function dll-filename))
    (when (and dir
               (file-exist-p (setq dll (merge-pathnames dll-filename dir))))
      (treeview-dll-define-function dll)
      (return))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(let ((treeview-id 0))
  (defun treeview-set-id (id)
    (setq treeview-id id))
  (defun treeview-get-id ()
    treeview-id)
  (defun treeview-open-p ()
    (not (or (null treeview-id) (eql treeview-id 0))))

  (defun treeview-create ()
    (setq treeview-id (treeview-dll-create (get-window-handle) (si:plugin-arg))))
  (defun treeview-create-ex (&optional (size 400) (pos XPIS_LEFT))
    (setq treeview-id (treeview-dll-create-ex (get-window-handle) (si:plugin-arg) size pos)))
  (defun treeview-close ()
    (treeview-dll-close treeview-id)
    (setq treeview-id 0))
  (defun treeview-get-hwnd ()
    (treeview-dll-get-hwnd treeview-id))
  (defun treeview-get-htree ()
    (treeview-dll-get-htree treeview-id))
  (defun treeview-modify-style (remove add flags)
    (treeview-dll-modify-style treeview-id remove add flags))

  (defun treeview-get-count ()
    (treeview-dll-get-count treeview-id))
  (defun treeview-get-next-item (hitem code)
    (treeview-dll-get-count treeview-id hitem code))
  (defun treeview-item-has-children (hitem)
    (treeview-dll-item-has-children treeview-id hitem))
  (defun treeview-get-child-item (hitem)
    (treeview-dll-get-child-item treeview-id hitem))
  (defun treeview-get-next-sibling-item (hitem)
    (treeview-dll-get-next-sibling-item treeview-id hitem))
  (defun treeview-get-prev-sibling-item (hitem)
    (treeview-dll-get-prev-sibling-item treeview-id hitem))
  (defun treeview-get-parent-item (hitem)
    (treeview-dll-get-parent-item treeview-id hitem))
  (defun treeview-get-first-visible-item (hitem)
    (treeview-dll-get-next-item treeview-id hitem TVGN_FIRSTVISIBLE))
  (defun treeview-get-next-visible-item (hitem)
    (treeview-dll-get-next-item treeview-id hitem TVGN_NEXTVISIBLE))
  (defun treeview-get-prev-visible-item (hitem)
    (treeview-dll-get-next-item treeview-id hitem TVGN_PREVIOUSVISIBLE))
  (defun treeview-get-selected-item ()
    (treeview-dll-get-selected-item treeview-id))
  (defun treeview-get-root-item ()
    (treeview-dll-get-root-item treeview-id))
  (defun treeview-get-item (pitem); TVITEM*
    (treeview-dll-get-item treeview-id pitem))
  (defun treeview-set-item (hitem mask text icon sicon state statemask lparam)
    (treeview-dll-set-item treeview-id hitem mask (si:make-string-chunk text) icon sicon state statemask lparam))
  (defun treeview-get-item-state (hitem statemask)
    (treeview-dll-get-item-state treeview-id hitem statemask))
  (defun treeview-set-item-state (hitem state statamask)
    (treeview-dll-set-item-state treeview-id hitem state statemask))
  (defun treeview-get-item-text (hitem &optional (maxlen 256))
    (let ((text (si:make-chunk nil maxlen)))
      (treeview-dll-get-item-text treeview-id hitem text maxlen)
      (si:unpack-string text 0)))
  (defun treeview-set-item-text (hitem text)
    (treeview-dll-set-item-text treeview-id hitem (si:make-string-chunk text)))
  (defun treeview-get-item-data (hitem)
    (treeview-dll-get-item-data treeview-id hitem))
  (defun treeview-set-item-data (hitem data)
    (treeview-dll-set-item-data treeview-id hitem data))

  (defun treeview-get-bk-color ()
    (winapi:SendMessage (treeview-get-htree) TVM_GETBKCOLOR 0 0))
  (defun treeview-set-bk-color (color)
    (cond
     ((eq color t)
      (setq color CLR_DEFAULT))
     ((eq color nil)
      (setq color CLR_NONE)))
    (unless (eql color (treeview-get-bk-color))
      (winapi:SendMessage (treeview-get-htree) TVM_SETBKCOLOR color color)
      (RedrawWindow (treeview-get-htree) 0 0
                    (logior RDW_INVALIDATE RDW_ALLCHILDREN RDW_UPDATENOW))))
  (defun treeview-get-text-color ()
    (winapi:SendMessage (treeview-get-htree) TVM_GETTEXTCOLOR 0 0))
  (defun treeview-set-text-color (color)
    (cond
     ((eq color t)
      (setq color CLR_DEFAULT))
     ((eq color nil)
      (setq color CLR_NONE)))
    (unless (eql color (treeview-get-text-color))
      (winapi:SendMessage (treeview-get-htree) TVM_SETTEXTCOLOR color color)
      (RedrawWindow (treeview-get-htree) 0 0
                    (logior RDW_INVALIDATE RDW_ALLCHILDREN RDW_UPDATENOW))))
  (defun treeview-get-insert-mark-color ()
    (winapi:SendMessage (treeview-get-htree) TVM_GETINSERTMARKCOLOR 0 0))
  (defun treeview-set-insert-mark-color (color)
    (cond
     ((eq color t)
      (setq color CLR_DEFAULT))
     ((eq color nil)
      (setq color CLR_NONE)))
    (unless (eql color (treeview-get-insert-mark-color))
      (winapi:SendMessage (treeview-get-htree) TVM_SETINSERTMARKCOLOR color color)
      (RedrawWindow (treeview-get-htree) 0 0
                    (logior RDW_INVALIDATE RDW_ALLCHILDREN RDW_UPDATENOW))))

  (defun treeview-insert-item (text parent &key icon sicon (insertafter TVI_LAST)
                               (state 0) (statemask 0) (lparam 0))
    (let ((mask TVIF_TEXT))
      (if (null icon)
          (setq icon 0)
        (setq mask (logior mask TVIF_IMAGE)))
      (if (null sicon)
          (setq sicon 0)
        (setq mask (logior mask TVIF_SELECTEDIMAGE)))
      (treeview-dll-insert-item
       treeview-id mask (si:make-string-chunk text) icon sicon state statemask lparam parent insertafter)))
  (defun treeview-delete-item (hitem)
    (treeview-dll-delete-item treeview-id hitem))
  (defun treeview-delete-all-items ()
    (treeview-dll-delete-all-items treeview-id))
  (defun treeview-expand (hitem code)
    (treeview-dll-expand treeview-id hitem code))
  (defun treeview-select (hitem code)
    (treeview-dll-select treeview-id hitem code))
  (defun treeview-select-item (hitem)
    (treeview-dll-select treeview-id hitem TVGN_CARET))
  (defun treeview-edit-label (hitem)
    (treeview-dll-edit-label treeview-id hitem))
  (defun treeview-sort-children (hitem)
    (treeview-dll-sort-children treeview-id hitem))

  ;;
  (let (callback)
    (c:defun-c-callable c:void treeview-click-callback-imp ((HTREEITEM hitem))
      (funcall callback hitem))
    (defun treeview-click-callback (fn)
      (setq callback fn)
      (not (zerop (treeview-dll-set-click-callback treeview-id #'treeview-click-callback-imp)))))
  (let (callback)
    (c:defun-c-callable c:void treeview-dblclk-callback-imp ((HTREEITEM hitem))
      (funcall callback hitem))
    (defun treeview-dblclk-callback (fn)
      (setq callback fn)
      (not (zerop (treeview-dll-set-dblclk-callback treeview-id #'treeview-dblclk-callback-imp)))))
  (let (callback)
    (c:defun-c-callable c:void treeview-rclick-callback-imp ((HTREEITEM hitem))
      (funcall callback hitem))
    (defun treeview-rclick-callback (fn)
      (setq callback fn)
      (not (zerop (treeview-dll-set-rclick-callback treeview-id #'treeview-rclick-callback-imp)))))
  (let (callback)
    (c:defun-c-callable c:void treeview-keydown-callback-imp ((HTREEITEM hitem) (winapi:WORD vkey) (winapi:UINT flag))
      (funcall callback hitem vkey flag))
    (defun treeview-keydown-callback (fn)
      (setq callback fn)
      (not (zerop (treeview-dll-set-keydown-callback treeview-id #'treeview-keydown-callback-imp)))))
  (let ((callback) (maxlen 256))
    (c:defun-c-callable c:void treeview-edit-label-callback-imp ((HTREEITEM hitem) (LPCTSTR text))
      (funcall callback hitem (si:unpack-string (si:make-chunk nil maxlen nil text) 0)))
    (defun treeview-edit-label-callback (fn)
      (setq callback fn)
      (not (zerop (treeview-dll-set-edit-label-callback treeview-id #'treeview-edit-label-callback-imp)))))

  ;;
  (defun treeview-add-file-icon (filepath)
    (treeview-dll-add-file-icon treeview-id (si:make-string-chunk filepath)))
  (defun treeview-set-item-icon (hitem icon sicon)
    (treeview-dll-set-item treeview-id hitem (logior TVIF_IMAGE TVIF_SELECTEDIMAGE) 0 icon sicon 0 0 0))
  (defun treeview-simple-track-popup-menu (menu-format)
    (treeview-dll-simple-track-popup-menu (si:make-string-chunk menu-format)))
  (defun treeview-disable-char-jump (&optional (disable t))
    (treeview-dll-disable-char-jump treeview-id (if disable 1 0)))
  
  ;; ǉ
  (defun treeview-expand-p (hitem)
    (not (zerop (logand TVIS_EXPANDED (treeview-dll-get-item-state treeview-id hitem 0)))))
  (defun treeview-expand-expand (hitem &key all sibling)
    (treeview-dll-expand treeview-id hitem TVE_EXPAND))
  (defun treeview-expand-collapse (hitem &key all sibling)
    (treeview-dll-expand treeview-id hitem TVE_COLLAPSE))
  (defun treeview-expand-toggle (hitem)
    (treeview-dll-expand treeview-id hitem TVE_TOGGLE))

  (defun treeview-operation-up (hitem)
    (when (treeview-open-p)
      (setq hitem (treeview-get-prev-visible-item hitem))
      (if (and hitem (not (zerop hitem)))
          (treeview-select-item hitem))))
  (defun treeview-operation-down (hitem)
    (when (treeview-open-p)
      (setq hitem (treeview-get-next-visible-item hitem))
      (if (and hitem (not (zerop hitem)))
          (treeview-select-item hitem))))
  (defun treeview-operation-left (hitem)
    (when (treeview-open-p)
      (cond
       ((treeview-expand-p hitem)
        (treeview-expand-collapse hitem))
       ((progn
          (setq hitem (treeview-get-parent-item hitem))
          (and hitem (not (zerop hitem))))
        (treeview-select-item hitem)))))
  (defun treeview-operation-right (hitem)
    (when (treeview-open-p)
      (cond
       ((treeview-expand-p hitem)
        (treeview-select-item (treeview-get-child-item hitem)))
       ((treeview-item-has-children hitem)
        (treeview-expand-expand hitem)))))
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defvar *outline-size* 200)
(defvar *outline-position* XPIS_LEFT)

(defvar *outline-disable-char-jump* t)

(defvar *outline-bk-color* nil)
(defvar *outline-text-color* nil)
(defvar *outline-modify-bk-color* nil)
(defvar *outline-modify-text-color* nil)

(defvar *outline-action-immediately* nil)      ; s邩ۂ
(defvar-local *outline-range-type-narrow* nil) ; ʂ̃m[h͈̔͂܂ނۂ
(defvar-local *outline-view-restriction* nil)  ; \͈͂𐧌邩ۂ
(defvar-local *outline-view-emphasis* nil)     ; \邩ۂ

;;;;;;;;;;;; gp
;(defvar-local *outline-edit* nil)
;(defvar-local *outline-move-level* nil)
;(defvar-local *outline-move-position* nil)
;;;;;;;;;;;;

(defvar *outline-operation-up-keys* (list winapi:VK_P winapi:VK_J))
(defvar *outline-operation-down-keys* (list winapi:VK_N winapi:VK_K))
(defvar *outline-operation-left-keys* (list winapi:VK_B winapi:VK_H))
(defvar *outline-operation-right-keys* (list winapi:VK_F winapi:VK_L))
(defvar *outline-expand-toggle-keys* (list winapi:VK_SPACE))

(defvar *outline-action-keys* (list winapi:VK_RETURN))
(defvar *outline-focus-editor-keys* (list winapi:VK_TAB winapi:VK_F12 winapi:VK_MENU))
(defvar *outline-close-keys* (list winapi:VK_ESCAPE))
(defvar *outline-edit-label-keys* (list winapi:VK_F2))

(defvar *outline-make-regexp-list-dots*
  '("^\\.\\{1\\}\\([^\\.\n].*?\\)[ \t]*$"
    "^\\.\\{2\\}\\([^\\.\n].*?\\)[ \t]*$"
    "^\\.\\{3\\}\\([^\\.\n].*?\\)[ \t]*$"
    "^\\.\\{4\\}\\([^\\.\n].*?\\)[ \t]*$"
    "^\\.\\{5\\}\\([^\\.\n].*?\\)[ \t]*$"
    "^\\.\\{6\\}\\([^\\.\n].*?\\)[ \t]*$"
    "^\\.\\{7\\}\\([^\\.\n].*?\\)[ \t]*$"
    "^\\.\\{8\\}\\([^\\.\n].*?\\)[ \t]*$"
    "^\\.\\{9\\}\\([^\\.\n].*?\\)[ \t]*$"
    ))

(defvar-local *outline-make-regexp-list* *outline-make-regexp-list-dots*)
(defvar-local *outline-make-function* 'outline-make-regexp)
(defvar *outline-emphasis-attribute* '(:background 3 :bold t))

(defvar *outline-tag* 'outline-tree)
(defvar *outline-header-node-title* "<擪>")
(defvar *outline-dummy-node-title* "<dummy>")

(defvar *outline-open-hook* nil)
(defvar *outline-make-hook* nil)
(defvar *outline-close-hook* nil)
(defvar *outline-focus-editor-hook* nil)
(defvar *outline-focus-outline-hook* nil)

(defvar *outline-hash* (make-hash-table))
;; Ƃ肠蔲̂߁BȂŁB
(defvar *outline-buffer-hash* (make-hash-table))

(defvar-local *outline-buffer-latest* nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun outline-operation-up (&optional (hitem (treeview-get-selected-item))
                             &option (action *outline-action-immediately*))
  (interactive)
  (treeview-operation-up hitem)
  (when action
    (outline-node-action)))
(defun outline-operation-down (&optional (hitem (treeview-get-selected-item))
                               &option (action *outline-action-immediately*))
  (interactive)
  (treeview-operation-down hitem)
  (when action
    (outline-node-action)))
(defun outline-operation-left (&optional (hitem (treeview-get-selected-item))
                               &option (action *outline-action-immediately*))
  (interactive)
  (treeview-operation-left hitem)
  (when action
    (outline-node-action)))
(defun outline-operation-right (&optional (hitem (treeview-get-selected-item))
                                &option (action *outline-action-immediately*))
  (interactive)
  (treeview-operation-right hitem)
  (when action
    (outline-node-action)))
(defun outline-expand-toggle (&optional (hitem (treeview-get-selected-item)))
  (interactive)
  (treeview-expand-toggle hitem))

;(defun outline-delete-highlight ()
;  (if *outline-view-emphasis*
;      (delete-text-attributes *outline-tag*)))

(defun outline-buffer-modified (buffer operation from to undo-p)
  (when *outline-buffer-latest*
    (setq *outline-buffer-latest* nil)
    (if *outline-modify-bk-color*
        (treeview-set-bk-color *outline-modify-bk-color*))
    (if *outline-modify-text-color*
        (treeview-set-text-color *outline-modify-text-color*))))

(c:define-dll-entry winapi:HWND SetFocus (winapi:HWND) "user32")
(defun outline-focus-editor ()
  (interactive)
  (SetFocus (get-window-handle))
  (run-hooks '*outline-focus-editor-hook*))
(defun outline-focus-outline ()
  (interactive)
  (when (treeview-open-p)
    (SetFocus (treeview-get-hwnd)))
  (run-hooks '*outline-focus-outline-hook*))

(defun outline-hitem-valid-p (hitem)
  (and hitem (not (eql hitem 0))))

(defun outline-set-cursor-by-node (&optional (hitem (treeview-get-selected-item))
                                   &key (top nil))
  (interactive)
  (when (and (treeview-open-p)
             (outline-hitem-valid-p hitem))
    (outline-set-buffer hitem)
    (let ((po (point)))
      (multiple-value-bind (view-range restriction-range emphasis-range)
          (outline-get-ranges hitem)
        (when (and view-range
                   (or top
                       (< po (car view-range))
                       (< (cdr view-range) po)))
          (widen)
          (goto-char (car view-range))
          (recenter 3))
        ))))

; J[\ɑΉm[hȂ nil
(defun outline-set-node-by-cursor ()
  (interactive)
  (labels ((outline-set-node-by-cursor-1 (parent-hitem position)
             (unless (and (outline-hitem-valid-p parent-hitem)
                          (integerp position))
               (return-from outline-set-node-by-cursor-1 nil))
             (let (hitem child-hitem value wide-range)
               (when (not (zerop (treeview-item-has-children parent-hitem)))
                 (setq hitem (treeview-get-child-item parent-hitem))
                 (while (outline-hitem-valid-p hitem)
                   (setq value (gethash hitem *outline-hash*))
                   (case (car value)
                     ((:node :header-node)
                      (setq wide-range (nth 2 value))
                      (when (and wide-range
                                 (<= (car wide-range) position)
                                 (<= position (cdr wide-range)))
                        (return-from outline-set-node-by-cursor-1
                          (or (outline-set-node-by-cursor-1 hitem position) hitem))))
                     (t
                      (setq child-hitem (outline-set-node-by-cursor-1 hitem position))
                      (if child-hitem
                          (return-from outline-set-node-by-cursor-1 child-hitem))))
                   (setq hitem (treeview-get-next-sibling-item hitem)))))
             nil))
    (when (treeview-open-p)
      (let ((hitem (gethash (selected-buffer) *outline-buffer-hash*)) child-hitem)
        (when hitem
          (setq child-hitem (outline-set-node-by-cursor-1 hitem (point)))
          (treeview-select-item (or child-hitem hitem)))
        (or child-hitem hitem)))))

(defun outline-set-node-by-cursor-for-hook ()
  (interactive)
  (when (and (treeview-open-p)
             (not (find *this-command*
                        '(outline-make
                          outline-operation-up
                          outline-operation-down
                          outline-operation-left
                          outline-operation-right))))
    (outline-set-node-by-cursor)))

(defun outline-set-node-by-cursor-or-make ()
  (interactive)
  (or (and (treeview-open-p)
           *outline-buffer-latest*
           (outline-set-node-by-cursor))
      (outline-make)))

(defun outline-open ()
  (interactive)
  (unless (treeview-open-p)
    (treeview-create-ex *outline-size* *outline-position*)
    (treeview-set-bk-color *outline-bk-color*)
    (treeview-set-text-color *outline-text-color*)
    (clrhash *outline-hash*)
    (clrhash *outline-buffer-hash*)
    (add-hook '*delete-buffer-hook* 'outline-delete-buffer)
;    (add-hook '*pre-command-hook* 'outline-delete-highlight)
    (add-hook '*pre-command-hook* 'outline-unset-text-emphasis)
    (add-hook 'post-buffer-modified-hook 'outline-buffer-modified)
    ;;
    (treeview-modify-style 0
                           (logior TVS_HASBUTTONS TVS_HASLINES TVS_LINESATROOT
;                                  TVS_EDITLABELS
                                   TVS_SHOWSELALWAYS) 0)
    ;;
    (treeview-disable-char-jump *outline-disable-char-jump*)
    ;;
    (treeview-click-callback
     #'(lambda (hitem)
         (when *outline-action-immediately*
           (stop-timer 'outline-node-action)
           (start-timer 0.01 'outline-node-action t))))
    (treeview-dblclk-callback
     #'(lambda (hitem)
         (unless *outline-action-immediately*
           (stop-timer 'outline-node-action)
           (start-timer 0.01 'outline-node-action t))))
    ;;
    (treeview-keydown-callback
     #'(lambda (hitem vkey flag)
         (cond
          ((find vkey *outline-operation-up-keys*)
           (outline-operation-up hitem :action nil))
          ((find vkey *outline-operation-down-keys*)
           (outline-operation-down hitem :action nil))
          ((find vkey *outline-operation-left-keys*)
           (outline-operation-left hitem :action nil))
          ((find vkey *outline-operation-right-keys*)
           (outline-operation-right hitem :action nil))
          ((find vkey *outline-expand-toggle-keys*)
           (outline-expand-toggle hitem))
          ((find vkey *outline-action-keys*)
           (stop-timer 'outline-node-action)
           (start-timer 0.01 'outline-node-action t))
          ((find vkey *outline-focus-editor-keys*)
           (outline-focus-editor))
;          ((find vkey *outline-edit-label-keys*)
;           (treeview-edit-label hitem))
          ((find vkey *outline-close-keys*)
           (outline-close))
          (t
;           (message "[0x~X] [0x~X]" vkey flag)
           )
          )
#|
         (when (and *outline-action-immediately*
                    (find vkey (append (list winapi:VK_UP winapi:VK_DOWN winapi:VK_LEFT winapi:VK_RIGHT)
                                       *outline-operation-up-keys*
                                       *outline-operation-down-keys*
                                       *outline-operation-left-keys*
                                       *outline-operation-right-keys*)))
           (outline-node-action))
|#
         (let (tmp-hitem)
           (when *outline-action-immediately*
             (cond
              ((find vkey (append *outline-operation-up-keys*
                                  *outline-operation-down-keys*
                                  *outline-operation-left-keys*
                                  *outline-operation-right-keys*))
               (outline-node-action))
              ((eql vkey winapi:VK_UP)
               (setq tmp-hitem (treeview-get-prev-visible-item hitem))
               (if (outline-hitem-valid-p tmp-hitem)
                   (progn
                     (treeview-select-item tmp-hitem)
                     (outline-node-action)
                     (treeview-select-item hitem))
                 (outline-node-action)))
              ((eql vkey winapi:VK_DOWN)
               (setq tmp-hitem (treeview-get-next-visible-item hitem))
               (if (outline-hitem-valid-p tmp-hitem)
                   (progn
                     (treeview-select-item tmp-hitem)
                     (outline-node-action)
                     (treeview-select-item hitem))
                 (outline-node-action)))
              ((eql vkey winapi:VK_LEFT)
               (unless (treeview-expand-p hitem)
                 (setq tmp-hitem (treeview-get-parent-item hitem)))
               (if (outline-hitem-valid-p tmp-hitem)
                   (progn
                     (treeview-select-item tmp-hitem)
                     (outline-node-action)
                     (treeview-select-item hitem))
                 (outline-node-action)))
              ((eql vkey winapi:VK_RIGHT)
               (when (treeview-expand-p hitem)
                 (setq tmp-hitem (treeview-get-child-item hitem)))
               (if (outline-hitem-valid-p tmp-hitem)
                   (progn
                     (treeview-select-item tmp-hitem)
                     (outline-node-action)
                     (treeview-select-item hitem))
                 (outline-node-action)))
              )))))
    (outline-focus-editor)
    (run-hooks '*outline-open-hook*)))

(defun outline-close ()
  (interactive)
  (widen)
  (delete-hook '*delete-buffer-hook* 'outline-delete-buffer)
; (delete-hook '*pre-command-hook* 'outline-delete-highlight)
  (delete-hook '*pre-command-hook* 'outline-unset-text-emphasis)
  (delete-hook 'post-buffer-modified-hook 'outline-buffer-modified)
  (outline-focus-editor)
  (treeview-close)
  (run-hooks '*outline-close-hook*))

(defun outline-delete-buffer (buffer)
  (let ((hitem (gethash buffer *outline-buffer-hash*)))
    (when (and (treeview-open-p) (integerp hitem))
      (treeview-delete-item hitem)
      (setf (gethash buffer *outline-buffer-hash*) nil)))
  t)

(defun outline-make (&optional (following nil))
  (interactive "P")
  (outline-open)
  (treeview-set-bk-color *outline-bk-color*)
  (treeview-set-text-color *outline-text-color*)
  (save-excursion
    (save-restriction
      (widen)
      (if following
          (narrow-to-region (progn (goto-bol) (point)) (point-max)))
      (let ((root-hitem (gethash (selected-buffer) *outline-buffer-hash*)))
        ;; Ƀobt@ɑΉ node ݂邩ǂ
        (if root-hitem
            (progn
              (while (not (eql 0 (treeview-item-has-children root-hitem)))
                (treeview-delete-item (treeview-get-child-item root-hitem)))
              ;; obt@ύXĂꍇւ̑Ώ
              (treeview-set-item-text root-hitem (buffer-name (selected-buffer))))
          (progn
            (setq root-hitem
                  (treeview-insert-item (buffer-name (selected-buffer)) TVI_ROOT))
            (setf (gethash root-hitem *outline-hash*)
                  `(:buffer-node () ,(selected-buffer) ()))
            (setf (gethash (selected-buffer) *outline-buffer-hash*) root-hitem)))
        ;; 쐬
        (when (or (functionp *outline-make-function*)
                  (and (symbolp *outline-make-function*)
                       (fboundp *outline-make-function*)))
          (long-operation
            (funcall *outline-make-function* root-hitem)))
        (outline-focus-editor)
        (refresh-screen))
      (outline-set-node-by-cursor)
      (setq *outline-buffer-latest* t)
      (enable-post-buffer-modified-hook t)))
  (run-hooks '*outline-make-hook*))

#|
;; Kv
(let (text-attribute-list point)
  (defun outline-unset-text-emphasis ()
    (when text-attribute-list
      (when point
        (delete-text-attribute-point point)
        (setq point nil))
      (dolist (text-attribute text-attribute-list)
        (apply #'set-text-attribute text-attribute))
      (setq text-attribute-list nil)
      (delete-text-attributes *outline-tag*)))
  (defun outline-set-text-emphasis (range)
    (outline-unset-text-emphasis)
    (setq text-attribute-list (list-text-attributes (car range) (cdr range)))
    (setq point (car range))
    (apply #'set-text-attribute
           (append (list (car range) (cdr range) *outline-tag*)
                   *outline-emphasis-attribute*))))
|#
;; Kv
(defun outline-unset-text-emphasis ()
  (when *outline-view-emphasis*
    (delete-text-attributes *outline-tag*)))
(defun outline-set-text-emphasis (range)
  (outline-unset-text-emphasis)
  (apply #'set-text-attribute
         (append (list (car range) (cdr range) *outline-tag*)
                 *outline-emphasis-attribute*)))

(defun outline-node-action (&optional (hitem (treeview-get-selected-item)))
  (interactive)
  (let (value func)
    (setq value (gethash hitem *outline-hash*))
    (setq func (nth 1 value))
    (if func
        (funcall func)
      (case (car value)
        (:buffer-node
         (outline-set-buffer)
         (widen)
         (refresh-screen))
        ((:node :header-node)
         (outline-set-cursor-by-node hitem :top t)
         (multiple-value-bind (view-range restriction-range emphasis-range)
             (outline-get-ranges hitem)
           (widen)
           (when restriction-range
             (narrow-to-region (car restriction-range) (cdr restriction-range)))
           (when emphasis-range
;            (outline-delete-highlight)
             (outline-set-text-emphasis emphasis-range)
;            (set-text-attribute (car emphasis-range) (cdr emphasis-range) *outline-tag* :bold t)
             ))
         (refresh-screen))))))

(defun outline-get-ranges (&optional (hitem (treeview-get-selected-item)))
  (when (and (treeview-open-p)
             (outline-hitem-valid-p hitem))
    (let (value wide-range narrow-range view-range restriction-range emphasis-range)
      (setq value (gethash hitem *outline-hash*))
      (when (find (car value) '(:node :header-node :dummy-node :info-node))
        (setq wide-range (nth 2 value))
        (setq narrow-range (nth 3 value))
        (setq title-range (nth 4 value))
        (if (and *outline-range-type-narrow* narrow-range)
            (setq view-range narrow-range)
          (setq view-range wide-range))
        (if *outline-view-restriction*
            (setq restriction-range view-range))
        (when *outline-view-emphasis*
          (if restriction-range
              (setq emphasis-range title-range)
            (setq emphasis-range view-range)))
        (values view-range restriction-range emphasis-range)))))

(defun outline-get-buffer-node-hitem (&optional hitem)
  (let (value)
    (unless hitem
      (setq hitem (treeview-get-selected-item)))
    (setq value (gethash hitem *outline-hash*))
    (while (and value (not (eq (car value) :buffer-node)))
      (setq hitem (treeview-get-parent-item hitem))
      (setq value (gethash hitem *outline-hash*)))
    (if (eq (car value) :buffer-node)
        (values hitem value)
      nil)))

(defun outline-set-buffer (&optional hitem)
  (let (value buffer window)
    (multiple-value-bind (hitem value)
        (outline-get-buffer-node-hitem hitem)
      (when value
        (setq buffer (nth 2 value))
        (setq window (get-buffer-window buffer))
        (if window
            (set-window window)
          (set-buffer buffer))))))

;;; K\AEgC
(defun outline-make-regexp (root-hitem)
  (labels ((outline-make-regexp-1 (root-hitem current-depth depth regexp-list)
             (let ((regexp (car regexp-list)) title hitem value-list begin pre-begin title-begin title-end
                   wide-range narrow-range title-range next-node-point)
               (save-excursion
                 (goto-char (point-min))
                 (while (scan-buffer regexp :regexp t)
;                  (do-events)
                   (setq pre-begin begin)
                   (setq begin (point))
                   (when pre-begin
                     ;; ͈̔͂sn܂ꍇ́A݂͈̔͂ҏWĂ
                     ;; ͈̔͂sn܂邱Ƃɉe^Ȃ悤ɓʂɔz
                     (if (bolp)
                         (push (list (cons pre-begin (1- begin)) (cons title-begin title-end)) value-list)
                       (push (list (cons pre-begin begin) (cons title-begin title-end)) value-list)))
                   ;;
                   (if (match-string 1)
                       (progn
                         (setq title-begin (match-beginning 1))
                         (setq title-end (match-end 1)))
                     (save-excursion
                       (goto-char (match-end 0))
                       (setq title-begin (point))
                       (setq title-end (progn (goto-eol) (point)))))
                   (goto-char (match-end 0)))
                 (when begin
                   (push (list (cons begin (point-max)) (cons title-begin title-end)) value-list))
                 (setq value-list (nreverse value-list))

                 (dolist (value value-list)
                   (setq wide-range (nth 0 value))
                   (setq title-range (nth 1 value))
                   (setq hitem (treeview-insert-item
                                (buffer-substring (car title-range) (cdr title-range))
                                root-hitem))
                   (if (null (cdr regexp-list))
                       (progn
                         (setq narrow-range (copy-seq wide-range))
                         (setf (gethash hitem *outline-hash*) `(:node () ,wide-range ,narrow-range ,title-range)))
                     (save-restriction
                       (narrow-to-region (car wide-range) (cdr wide-range))
                       (setq next-node-point (outline-make-regexp-1 hitem (1+ current-depth) (1+ depth) (cdr regexp-list)))
                       (if (null next-node-point)
                           (setq narrow-range (copy-seq wide-range))
                         (save-excursion
                           (widen)
                           (goto-char next-node-point)
                           (if (bolp)
                               (setq narrow-range (cons (car wide-range) (1- next-node-point)))
                             (setq narrow-range (cons (car wide-range) next-node-point)))))
                       (setf (gethash hitem *outline-hash*) `(:node () ,wide-range ,narrow-range ,title-range)))))
                 (caaar value-list)))))
    (let (hitem next-node-point wide-range narrow-range title-range)
      (setq hitem (treeview-insert-item *outline-header-node-title* root-hitem))
      (setq next-node-point (outline-make-regexp-1 root-hitem 0 0 *outline-make-regexp-list*))
      (if (and next-node-point (plusp next-node-point))
        (progn
          (save-excursion
            (goto-char next-node-point)
            (if (bolp)
                (setq wide-range (cons 0 (1- next-node-point)))
              (setq wide-range (cons 0 next-node-point))))
          (setq narrow-range (copy-seq wide-range))
          (setq title-range nil)
          (setf (gethash hitem *outline-hash*)
                `(:header-node () ,wide-range ,narrow-range ,title-range)))
        (treeview-delete-item hitem))
      (if next-node-point t nil))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun outline-make-text-mode (root-hitem)
  (unless (outline-make-regexp root-hitem)
    (outline-make-topic root-hitem)))

;;; topic p
(defvar *outline-topic-mark-string* "i(m[uwyE")
(defvar *outline-topic-mark-string-group-list*
  '("PQRSTUVWXO" "@ABCDEFGHIJKLMNOPQRS"
    "TUVWXYZ[\]" "OlܘZ\Q"))
(defun outline-make-topic (root-hitem)
  (labels ((outline-make-topic-1 (root-hitem rest-mark-groups)
             (let (c all-mark-regexp current-mark-regexp current-mark-group
                   title hitem value-list begin pre-begin title-begin title-end
                   wide-range narrow-range title-range next-node-point)
               (setq all-mark-regexp
                     (compile-regexp (format nil "^[ \t@]*[~{~A~}]" rest-mark-groups)))
               (save-excursion
                 (goto-char (point-min))
                 (unless (scan-buffer all-mark-regexp :regexp t :tail t)
                   (return-from outline-make-topic-1 nil))
                 (setq c (char-before (point)))
                 (dotimes (i (length rest-mark-groups))
                   (when (find c (nth i rest-mark-groups))
                     (setq current-mark-group (nth i rest-mark-groups))
                     (setq rest-mark-groups (nconc (subseq rest-mark-groups 0 i)
                                                   (subseq rest-mark-groups (1+ i))))
                     (return)))
                 (setq current-mark-regexp
                       (compile-regexp (format nil "^[ \t@]*\\([~A].*\\)" current-mark-group)))
                 (goto-bol)
                 (while (scan-buffer current-mark-regexp :regexp t)
;                  (do-events)
                   (setq pre-begin begin)
                   (setq begin (point))
                   (when pre-begin
                     (push (list (cons pre-begin (1- begin)) (cons title-begin title-end)) value-list))
                   (setq title-begin (match-beginning 1))
                   (setq title-end (match-end 1))
                   (goto-char (match-end 0)))
                 (when begin
                   (push (list (cons begin (point-max)) (cons title-begin title-end)) value-list))
                 (setq value-list (nreverse value-list))
                 (dolist (value value-list)
                   (setq wide-range (nth 0 value))
                   (setq title-range (nth 1 value))
                   (setq hitem (treeview-insert-item
                                (buffer-substring (car title-range) (cdr title-range))
                                root-hitem))
                   (if (null rest-mark-groups)
                       (progn
                         (setq narrow-range (copy-seq wide-range))
                         (setf (gethash hitem *outline-hash*) `(:node () ,wide-range ,narrow-range ,title-range)))
                     (save-restriction
                       (narrow-to-region (car wide-range) (cdr wide-range))
                       (setq next-node-point (outline-make-topic-1 hitem rest-mark-groups))
                       (if (null next-node-point)
                           (setq narrow-range (copy-seq wide-range))
                         (setq narrow-range (cons (car wide-range) (1- next-node-point))))
                       (setf (gethash hitem *outline-hash*)
                             `(:node () ,wide-range ,narrow-range ,title-range)))))
                 (caaar value-list)))))
    (let (hitem next-node-point wide-range narrow-range title-range rest-mark-groups)
      (setq rest-mark-groups (append (map 'list 'string *outline-topic-mark-string*)
                                     *outline-topic-mark-string-group-list*))
      (setq hitem (treeview-insert-item *outline-header-node-title* root-hitem))
      (setq next-node-point (outline-make-topic-1 root-hitem rest-mark-groups))
      (if (and next-node-point (plusp next-node-point))
        (progn
          (setq wide-range (cons 0 (1- next-node-point)))
          (setq narrow-range (copy-seq wide-range))
          (setq title-range nil)
          (setf (gethash hitem *outline-hash*)
                `(:header-node () ,wide-range ,narrow-range ,title-range)))
        (treeview-delete-item hitem))
      (if next-node-point t nil))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun outline-make-lisp-mode (root-hitem)
  (flet ((outline-make-lisp-mode-defvar-type (root-hitem heading regexp)
           (let (section-hitem hitem from to lst name val doc)
             (goto-char (point-min))
             (setq section-hitem (treeview-insert-item heading root-hitem))
             (while (scan-buffer regexp :regexp t)
;              (do-events)
               (setq from (point))
               (skip-chars-forward " \t")
               (when (and (eq (parse-point-syntax) nil)
                          (goto-matched-parenthesis))
                 (setq to (1+ (point)))
                 (with-input-from-buffer ((selected-buffer) from)
                   (setq lst (read *standard-input* nil)))
                 (when (<= 2 (length lst))
                   (setq name (nth 1 lst)))
                 (setq hitem (treeview-insert-item (format nil "~S" name) section-hitem))
                 (setf (gethash hitem *outline-hash*)
                       `(:node nil ,(cons from to) nil nil))
                 (setq doc (nth 3 lst))
                 (when (stringp doc)
                   (treeview-insert-item (concat "y" doc "z") hitem))
                 (when (<= 3 (length lst))
                   (setq val (nth 2 lst))
                   (treeview-insert-item (format nil "~S" val) hitem)))
               (goto-char (match-end 0)))
             (if hitem
                 (setf (gethash section-hitem *outline-hash*)
                       `(:info-node nil nil nil nil))
               (treeview-delete-item section-hitem))))
         (outline-make-lisp-mode-defun-type (root-hitem heading regexp)
           (let (section-hitem hitem from to lst name doc args)
             (goto-char (point-min))
             (setq section-hitem (treeview-insert-item heading root-hitem))
             (while (scan-buffer regexp :regexp t)
;              (do-events)
               (setq from (point))
               (skip-chars-forward " \t")
               (when (and (eq (parse-point-syntax) nil)
                          (goto-matched-parenthesis))
                 (setq to (1+ (point)))
                 (with-input-from-buffer ((selected-buffer) from)
                   (setq lst (read *standard-input* nil)))
                 (when (<= 2 (length lst))
                   (setq name (nth 1 lst)))
                 (setq hitem (treeview-insert-item (format nil "~S" name) section-hitem))
                 (setf (gethash hitem *outline-hash*)
                       `(:node nil ,(cons from to) nil nil))
                 (setq doc (nth 3 lst))
                 (when (stringp doc)
                   (treeview-insert-item (concat "y" doc "z") hitem))
                 (when (<= 3 (length lst))
                   (setq args (nth 2 lst))
                   (dolist (arg args)
                     (treeview-insert-item (format nil "~S" arg) hitem))))
               (goto-char (match-end 0)))
             (if hitem
                 (setf (gethash section-hitem *outline-hash*)
                       `(:info-node nil nil nil nil))
               (treeview-delete-item section-hitem))))
         )
    (save-excursion
      (outline-make-lisp-mode-defvar-type
       root-hitem "[defvar-local]" (compile-regexp "[ \t]*(defvar-local\\_S"))
      (outline-make-lisp-mode-defvar-type
       root-hitem "[defvar]" (compile-regexp "[ \t]*(defvar\\_S"))
      (outline-make-lisp-mode-defun-type
       root-hitem "[defun]" (compile-regexp "[ \t]*(defun\\_S"))
      (outline-make-lisp-mode-defun-type
       root-hitem "[defmacro]" (compile-regexp "[ \t]*(defmacro\\_S"))
      )))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun outline-make-tag-mode (root-hitem)
  (let (hitem nest tagname wide-from wide-to narrow-from narrow-to tag)
    (save-excursion
      (goto-char (point-min))
      (while (scan-buffer "<\\([^/][^> ]*\\)" :regexp t :tail t :case-fold t)
;       (do-events)
        (when (eq (parse-point-syntax (match-beginning 0)) nil)
          (setq tagname (match-string 1))
          (skip-syntax-spec-forward "^}")
          (forward-char)
          (setq wide-from (match-beginning 0))
          (setq narrow-from (point))
          (setq tag (buffer-substring (match-beginning 0) (point)))
          (setq nest 1)
          ;; ^OT
          (while (scan-buffer (concat "<\\(/\\)?\\(" (regexp-quote tagname) "\\)[ \t\n]*>")
                              :regexp t :tail t :case-fold t)
            (when (eq (parse-point-syntax (match-beginning 0)) nil)
              (cond ((match-string 1)
                     (decf nest))
                    ((match-string 2)
                     (incf nest)))
              (when (= nest 0)
;                (setq wide-to (1+ (match-end 0)))
                (setq wide-to (match-end 0))
                (setq narrow-to (match-beginning 0))
                (return))))
          (if (= nest 0)
              ;; ^Oꍇ
              (progn
                (setq hitem (treeview-insert-item tag root-hitem))
                (setf (gethash hitem *outline-hash*)
                      `(:node nil ,(cons wide-from wide-to) ,(cons narrow-from narrow-to) nil))
                (save-restriction
                  (narrow-to-region narrow-from narrow-to)
                  (outline-make-tag-mode hitem)))
            ;; ^OȂꍇ
            (goto-char narrow-from)))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun outline-setting-text-mode ()
  (setq *outline-make-function* 'outline-make-text-mode))
(defun outline-setting-lisp-mode ()
  (setq *outline-make-function* 'outline-make-lisp-mode))
(defun outline-setting-tag-mode ()
  (setq *outline-make-function* 'outline-make-tag-mode))
(add-hook 'ed:*lisp-mode-hook* 'outline-setting-lisp-mode)
(add-hook 'ed:*text-mode-hook* 'outline-setting-text-mode)
(add-hook 'ed:*fundamental-mode-hook* 'outline-setting-text-mode)

(defun outline-toggle-action-immediately ()
  (interactive)
  (setq *outline-action-immediately* (not *outline-action-immediately*)))
(defun outline-toggle-range-type-narrow ()
  (interactive)
  (setq *outline-range-type-narrow* (not *outline-range-type-narrow*)))
(defun outline-toggle-view-restriction ()
  (interactive)
  (if *outline-view-restriction*
      (widen))
  (setq *outline-view-restriction* (not *outline-view-restriction*)))
(defun outline-toggle-view-emphasis ()
  (interactive)
  (if *outline-view-emphasis*
;     (outline-delete-highlight)
    (outline-unset-text-emphasis)
    )
  (setq *outline-view-emphasis* (not *outline-view-emphasis*)))
(defun outline-toggle-chase ()
  (interactive)
  (if (find 'outline-set-node-by-cursor-for-hook *post-command-hook*)
      (delete-hook '*post-command-hook* 'outline-set-node-by-cursor-for-hook)
    (add-hook '*post-command-hook* 'outline-set-node-by-cursor-for-hook)))
(defun toggle-hide-restricted-region ()
  (interactive)
  (setq hide-restricted-region (not hide-restricted-region)))

#|
;;; dialog, property-sheet
(defvar *outline-prop-page-template*
  '(dialog 0 0 195 195
    (:caption "ײ")
    (:control
     (:button immediately "s(&I)" #x50010003 7 7 110 10)
     (:button narrow "͈͂͋(&N)" #x50010003 7 18 135 10)
     (:button restriction "\͈͂𐧌(&R)" #x50010003 7 29 123 10)
     (:button emphasis "\(&E)" #x50010003 7 40 86 10)
     (:button chase "m[hJ[\ɒǏ](&C)" #x50010003 7 51 141 10)
     (:button hide "*͈͂B(&H)" #x50010003 7 51 141 10))))
(add-option-prop-page
 'outline-tree
 *outline-prop-page-template*
 nil
 nil
 nil)
|#

;;; tool-bar
(defun tool-bar-update-close ()
  (or (treeview-open-p) :disable))
(defun tool-bar-update-action-immediately ()
  (cond ((not (treeview-open-p)) :disable)
        (*outline-action-immediately* :check)))
(defun tool-bar-update-range-type-narrow ()
  (cond ((not (treeview-open-p)) :disable)
        (*outline-range-type-narrow* :check)))
(defun tool-bar-update-view-restriction ()
  (cond ((not (treeview-open-p)) :disable)
        (*outline-view-restriction* :check)))
(defun tool-bar-update-view-emphasis ()
  (cond ((not (treeview-open-p)) :disable)
        (*outline-view-emphasis* :check)))
(defun tool-bar-update-chase ()
  (cond ((not (treeview-open-p)) :disable)
        ((find 'outline-set-node-by-cursor-for-hook *post-command-hook*) :check)))
(defun tool-bar-update-restricted-region ()
  (and hide-restricted-region :check))

(defun outline-tree-tool-bar ()
  (create-tool-bar
   'outline-tree-tool-bar
   (merge-pathnames "outline-tree-toolbar.bmp" (etc-path))
   '(("outline 쐬(XV)" 0 outline-make)
     ("" 1 outline-close tool-bar-update-close)
     :sep
     ("m[hs" 3 outline-toggle-action-immediately tool-bar-update-action-immediately)
     ("J[\ɒǏ]" 7 outline-toggle-chase tool-bar-update-chase)
     :sep
     ("͈̓^CvF" 6 outline-toggle-range-type-narrow tool-bar-update-range-type-narrow)
     ("\͈͐" 4 outline-toggle-view-restriction tool-bar-update-view-restriction)
     ("\" 5 outline-toggle-view-emphasis tool-bar-update-view-emphasis)
     ("͈͂̉B" 2 toggle-hide-restricted-region tool-bar-update-restricted-region)
     )))

; tool-bar o^
(define-command-bar 'outline-tree-tool-bar "Outline(&O)")

; tool-bar 폜
;(delete-command-bar 'outline-tree::outline-tree-tool-bar)

;;; uninstall
(defun uninstall-outline-tree ()
  "outline-tree.l ̃ACXg[x"
  (interactive)
  (delete-command-bar 'outline-tree::outline-tree-tool-bar))

;;; outline-tree.l ends here
